// PartView.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "lco.h"

#include "Draw.h"
#include "PartInfo.h"
#include "PartView.h"
#include "LCoFont.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



/////////////////////////////////////////////////////////////////////////////
// CPartView

CPartView::CPartView()
{
	m_pPartInfo=NULL;
	m_nSelectLTRB=0;
	m_nSelectOffset=0;
	m_nSelectBlock=0;
	m_pointWindowOrg=CPoint(0,0);
	m_sizeView=CSize(0,0);
	m_bSetFocus=FALSE;
}

CPartView::~CPartView()
{
}



BEGIN_MESSAGE_MAP(CPartView, CWnd)
	//{{AFX_MSG_MAP(CPartView)
	ON_WM_PAINT()
	ON_WM_SIZE()
	ON_WM_VSCROLL()
	ON_WM_HSCROLL()
	ON_WM_SETFOCUS()
	ON_WM_KILLFOCUS()
	ON_WM_LBUTTONDOWN()
	ON_WM_KEYDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()



//eEChEPVN_SELCHANGE𑗂
void CPartView::PostSelChange()
{
	int nID=GetDlgCtrlID();
	CWnd* pWnd=GetParent();
	if(pWnd) pWnd->PostMessage(WM_COMMAND,
		MAKELONG(nID,PVN_SELCHANGE),(LPARAM)m_hWnd);
}

//iւ̃|C^ݒ肷
void CPartView::SetPartInfo( CLCoPartInfo* pPartInfo)
{
	TRACE("CPartView::SetPartInfo()\n");
	m_pPartInfo=pPartInfo;
	m_nSelectLTRB=0;
	m_nSelectOffset=0;
	m_nSelectBlock=0;

	m_pointWindowOrg=CPoint(0,0);
	if(m_pPartInfo){
		m_sizeView.cx=m_pPartInfo->m_size.cx*10+1+PART_MARGIN*2;
		m_sizeView.cy=m_pPartInfo->m_size.cy*10+1+PART_MARGIN*2;
	}else{
		m_sizeView=CSize(0,0);
	}

	Resize();
	Invalidate();
}



void CPartView::SetSelectPin(int nLTRB,  int nOffset)
{

	if(!m_pPartInfo){
		nLTRB=nOffset=0;
	}else{
		switch(nLTRB){
		case 0:
		case 2:
			if(nOffset<0 || nOffset>m_pPartInfo->m_size.cy) return;
			break;
		case 1:
		case 3:
			if(nOffset<0 || nOffset>m_pPartInfo->m_size.cx) return;
			break;
		default:
			return;
		}
	}
	m_nSelectLTRB	=nLTRB;
	m_nSelectOffset	=nOffset;
}

void CPartView::GetSelectPin(int* pnLTRB,int* pnOffset)
{
	if(!m_pPartInfo){
		*pnLTRB		=0;
		*pnOffset	=0;
	}else{
		*pnLTRB		=m_nSelectLTRB;
		*pnOffset	=m_nSelectOffset;
	}
}

void CPartView::SetBlock(int nBlock)
{
	if(!m_pPartInfo) return;
	if(nBlock<0 || nBlock>=m_pPartInfo->m_nBlock) return;
	m_nSelectBlock=nBlock;
	Invalidate();
}

int  CPartView::GetBlock()
{
	if(!m_pPartInfo) return 0;
	else return m_nSelectBlock;
}



/////////////////////////////////////////////////////////////////////////////
// CPartView bZ[W nh

BOOL CPartView::PreTranslateMessage(MSG* pMsg) 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	if(pMsg->message==WM_KEYDOWN && pMsg->hwnd==m_hWnd){
		switch(pMsg->wParam){
		case VK_UP:
		case VK_DOWN:
		case VK_LEFT:
		case VK_RIGHT:
			::TranslateMessage(pMsg);
			::DispatchMessage(pMsg);
			return TRUE;
		}
	}
	return FALSE;	
}

//WindowOrg̐ݒ
void CPartView::PrepareDC(CDC* pDC)
{
	pDC->SetWindowOrg(m_pointWindowOrg);
}

//wi̕`
//
void CPartView::DrawBack(CDC* pDC,LPRECT prc)
{
	if(!m_pPartInfo) return;


	BOOL bUseLocalDC=FALSE;
	if(!pDC){
		bUseLocalDC=TRUE;
		pDC=new CClientDC(this);
		PrepareDC(pDC);
	}
	CRect rcDraw;
	if(prc) rcDraw=*prc;
	else rcDraw=CRect(0,0,m_sizeView.cx,m_sizeView.cy);

	

	int l,t,r,b;
	l=t=PART_MARGIN;
	r=l+m_pPartInfo->m_size.cx*10;
	b=t+m_pPartInfo->m_size.cy*10;

	CPen pen(PS_SOLID,1,RGB(0,255,0));
	CPen* pPenOld=pDC->SelectObject(&pen);

	pDC->MoveTo(l,t);
	pDC->LineTo(l,b);
	pDC->LineTo(r,b);
	pDC->LineTo(r,t);
	pDC->LineTo(l,t);

	int n,m;
	//c̉s̕`
	if(rcDraw.left<l && rcDraw.right>l-10){	
		if(t<rcDraw.top) n=rcDraw.top; else n=t;
		n=((n+9)/10)*10;
		if(b>rcDraw.bottom) m=rcDraw.bottom; else m=b;
		while(n<=m){
			pDC->MoveTo(l-10,n);
			pDC->LineTo(l,n);
			n+=10;
		}
	}
	//Ec̉s̕`
	if(rcDraw.left<r+10 && rcDraw.right>r){	
		if(t<rcDraw.top) n=rcDraw.top; else n=t;
		n=((n+9)/10)*10;
		if(b>rcDraw.bottom) m=rcDraw.bottom; else m=b;
		while(n<=m){
			pDC->MoveTo(r+10,n);
			pDC->LineTo(r,n);
			n+=10;
		}
	}
	//㉡̉s̕`
	if(rcDraw.top<t && rcDraw.bottom>t-10){	
		if(l<rcDraw.left) n=rcDraw.left; else n=l;
		n=((n+9)/10)*10;
		if(r>rcDraw.right) m=rcDraw.right; else m=r;
		while(n<=m){
			pDC->MoveTo(n,t-10);
			pDC->LineTo(n,t);
			n+=10;
		}
	}
	//̉s̕`
	if(rcDraw.top<b+10 && rcDraw.bottom>b){	
		if(l<rcDraw.left) n=rcDraw.left; else n=l;
		n=((n+9)/10)*10;
		if(r>rcDraw.right) m=rcDraw.right; else m=r;
		while(n<=m){
			pDC->MoveTo(n,b+10);
			pDC->LineTo(n,b);
			n+=10;
		}
	}



	pDC->SelectObject(pPenOld);
	if(bUseLocalDC) delete pDC;
}

#define PV_CURSOR_OFFSET	50

//J[\̕`
void CPartView::DrawCursor(CDC* pDC,BOOL bOn)
{
	if(!m_pPartInfo) return;
	BOOL bUseLocalDC=FALSE;
	if(!pDC){
		bUseLocalDC=TRUE;
		pDC=new CClientDC(this);
		PrepareDC(pDC);
	}
	COLORREF colEdge,colFill;
	int x,y;
	int nOffset=m_nSelectOffset*10;
	switch(m_nSelectLTRB){
	case 0:
		x=PART_MARGIN-PV_CURSOR_OFFSET;
		y=PART_MARGIN+nOffset;
		break;
	case 1:
		x=PART_MARGIN+nOffset;
		y=PART_MARGIN-PV_CURSOR_OFFSET;
		break;
	case 2:
		x=PART_MARGIN+m_pPartInfo->m_size.cx*10+PV_CURSOR_OFFSET;
		y=PART_MARGIN+nOffset;
		break;
	default:
		x=PART_MARGIN+nOffset;
		y=PART_MARGIN+m_pPartInfo->m_size.cy*10+PV_CURSOR_OFFSET;
		break;
	}
	if(!bOn){
		colEdge=colFill=RGB(255,255,255);
	}else{
		colEdge=RGB(0,0,255);
		if(m_bSetFocus) colFill=RGB(0,0,255);
		else			colFill=RGB(255,255,255);
	}
	CPen	pen(PS_SOLID,1,colEdge);
	CBrush	brush(colFill);
	CPen*   pOldPen   =pDC->SelectObject(&pen);
	CBrush* pOldBrush =pDC->SelectObject(&brush);
	pDC->Rectangle(x-4,y-4,x+5,y+5);
	pDC->SelectObject(pOldPen);
	pDC->SelectObject(pOldBrush);
	
	if(bUseLocalDC) delete pDC;
}



void CPartView::OnPaint() 
{
	CPaintDC dc(this); // `p̃foCX ReLXg
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	
	// `pbZ[WƂ CWnd::OnPaint() ĂяoĂ͂܂
	if(!m_pPartInfo) return;
	PrepareDC(&dc);					//WindowOrg̐ݒ
	CRect rcDraw=dc.m_ps.rcPaint;	//``𓾂
	dc.DPtoLP(&rcDraw);				//WindowOrg̐ݒ𔽉f

	DrawBack(&dc,&rcDraw);
	DrawBody(&dc,&rcDraw);
	POSITION pos=m_pPartInfo->m_listPin.GetHeadPosition();
	while(pos){
		CLCoPin* pPin=m_pPartInfo->m_listPin.GetNext(pos);
		DrawPin(&dc,&rcDraw,pPin);
	}

	DrawCursor(&dc);
}

//WM_SIZE𑗂
void CPartView::Resize()
{
	CRect rc;
	SendMessage(WM_SIZE,0,MAKELONG(m_sizeClient.cx,m_sizeClient.cy));
}


//WM_SIZE bZ[Wnh
void CPartView::OnSize(UINT nType, int cx, int cy) 
{
	CWnd::OnSize(nType, cx, cy);
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	m_sizeClient.cx=cx;
	m_sizeClient.cy=cy;

	SCROLLINFO si;
	si.fMask=SIF_RANGE|SIF_POS|SIF_PAGE;
	int nPos;

	nPos=m_pointWindowOrg.y;
	if(nPos>(m_sizeView.cy-m_sizeClient.cy))nPos=m_sizeView.cy-m_sizeClient.cy;
	if(nPos<0) nPos=0;
	si.nMin=0;
	si.nMax=m_sizeView.cy;
	si.nPage=m_sizeClient.cy;
	si.nPos =nPos;
	m_pointWindowOrg.y=nPos;
	SetScrollInfo(SB_VERT,&si,TRUE);

	nPos=m_pointWindowOrg.x;
	if(nPos>(m_sizeView.cx-m_sizeClient.cx))nPos=m_sizeView.cx-m_sizeClient.cx;
	if(nPos<0) nPos=0;
	si.nMin=0;
	si.nMax=m_sizeView.cx;
	si.nPage=m_sizeClient.cx;
	si.nPos =nPos;
	m_pointWindowOrg.x=nPos;
	SetScrollInfo(SB_HORZ,&si,TRUE);
}

//wItZbgԂ̐XN[ XN[ TRUE Ԃ
BOOL CPartView::VScrollOffset(int nOffset)
{
	SCROLLINFO si;
	GetScrollInfo(SB_VERT,&si);
	int nCurrentPos=si.nPos;
	int nNewPos=nCurrentPos+nOffset;

	if(nNewPos<0)nNewPos=0;
	else if(nNewPos>si.nMax-(int)si.nPage+1) nNewPos=si.nMax-si.nPage+1;
	si.nPos=m_pointWindowOrg.y=nNewPos;
	if(nCurrentPos!=nNewPos){
		ScrollWindow(0,nCurrentPos-nNewPos);
		si.fMask=SIF_RANGE|SIF_POS|SIF_PAGE;
		SetScrollInfo(SB_VERT,&si);
		UpdateWindow();
		return TRUE;
	}
	return FALSE;
}

//wItZbgԂ̐XN[ XN[ TRUE Ԃ
BOOL CPartView::HScrollOffset(int nOffset)
{
	SCROLLINFO si;
	GetScrollInfo(SB_HORZ,&si);
	int nCurrentPos=si.nPos;
	int nNewPos=nCurrentPos+nOffset;

	if(nNewPos<0)nNewPos=0;
	else if(nNewPos>si.nMax-(int)si.nPage+1) nNewPos=si.nMax-si.nPage+1;
	si.nPos=m_pointWindowOrg.x=nNewPos;
	if(nCurrentPos!=nNewPos){
		ScrollWindow(nCurrentPos-nNewPos,0);
		si.fMask=SIF_RANGE|SIF_POS|SIF_PAGE;
		SetScrollInfo(SB_HORZ,&si);
		UpdateWindow();
		return TRUE;
	}
	return FALSE;
}

//ws\悤ɃXN[
BOOL CPartView::ScrollToPin(int nLTRB,int nOffset)
{
	CPoint ptNew;
	nOffset=nOffset*10+PART_MARGIN;

	switch(nLTRB){
	case 0:
	case 2:
		if(nLTRB==0)ptNew.x=0;
		else ptNew.x=m_sizeView.cx-m_sizeClient.cx;
		
		if(m_pointWindowOrg.y+20 > nOffset) ptNew.y=nOffset-20;
		else if(m_pointWindowOrg.y+m_sizeClient.cy-20 < nOffset) ptNew.y=nOffset+20-m_sizeClient.cy;
		else ptNew.y=m_pointWindowOrg.y;
		break;

	default:
		if(nLTRB==1)ptNew.y=0;
		else ptNew.y=m_sizeView.cy-m_sizeClient.cy;

		if(m_pointWindowOrg.x+20 > nOffset) ptNew.x=nOffset-20;
		else if(m_pointWindowOrg.x+m_sizeClient.cx-20 < nOffset) ptNew.x=nOffset+20-m_sizeClient.cx;
		else ptNew.x=m_pointWindowOrg.x;
		break;
	}

	if(ptNew.x==m_pointWindowOrg.x && ptNew.y==m_pointWindowOrg.y) return FALSE;
	if(ptNew.x<0)ptNew.x=0;
	if(ptNew.y<0)ptNew.y=0;
	CPoint ptCurrent=m_pointWindowOrg;


	SCROLLINFO siH;
	SCROLLINFO siV;
	GetScrollInfo(SB_HORZ,&siH);
	GetScrollInfo(SB_VERT,&siV);

	siH.nPos=m_pointWindowOrg.x=ptNew.x;
	siV.nPos=m_pointWindowOrg.y=ptNew.y;

	ScrollWindow(ptCurrent.x-ptNew.x,ptCurrent.y-ptNew.y);
	siH.fMask=SIF_RANGE|SIF_POS|SIF_PAGE;
	SetScrollInfo(SB_HORZ,&siH);
	siV.fMask=SIF_RANGE|SIF_POS|SIF_PAGE;
	SetScrollInfo(SB_VERT,&siV);
	UpdateWindow();
	return TRUE;
}


void CPartView::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	SetFocus();
	int nOffset;
	switch(nSBCode){
	case SB_THUMBTRACK:
	case SB_THUMBPOSITION:
		nOffset=nPos-m_pointWindowOrg.y;
		break;
	case SB_LINEUP:
		nOffset=-20;
		break;
	case SB_LINEDOWN:
		nOffset=+20;
		break;
	case SB_PAGEUP:
		nOffset=-100;
		break;
	case SB_PAGEDOWN:
		nOffset=+100;
		break;
	default:
		return;
	}
	VScrollOffset(nOffset);
}

void CPartView::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	SetFocus();
	int nOffset;
	switch(nSBCode){
	case SB_THUMBTRACK:
	case SB_THUMBPOSITION:
		nOffset=nPos-m_pointWindowOrg.x;
		break;
	case SB_LINEUP:
		nOffset=-20;
		break;
	case SB_LINEDOWN:
		nOffset=+20;
		break;
	case SB_PAGEUP:
		nOffset=-100;
		break;
	case SB_PAGEDOWN:
		nOffset=+100;
		break;
	default:
		return;
	}
	HScrollOffset(nOffset);

}

void CPartView::OnSetFocus(CWnd* pOldWnd) 
{
	CWnd::OnSetFocus(pOldWnd);
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	TRACE("CPartView::OnSetFocus\n");
	m_bSetFocus=TRUE;
	DrawCursor(NULL);
	
}

void CPartView::OnKillFocus(CWnd* pNewWnd) 
{
	CWnd::OnKillFocus(pNewWnd);
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	TRACE("CPartView::OnKillFocus\n");
	m_bSetFocus=FALSE;
	DrawCursor(NULL);

}

//w肵ʒus̐[̏ォǂԂ
BOOL CPartView::IsOnPin(CPoint point,int* pnLTRB,int* pnOffset)
{
	if(!m_pPartInfo) return FALSE;
	int cx=m_pPartInfo->m_size.cx;
	int cy=m_pPartInfo->m_size.cy;

	point.x-=PART_MARGIN;
	point.y-=PART_MARGIN;


	if(point.x > -15 &&
	   point.x < -5)
	{//***** L *****
		point.y=(point.y+5)/10;
		if(point.y>=0 &&
		   point.y<=cy)
		{
			*pnLTRB=0;
			*pnOffset=point.y;
			return TRUE;
		}
	}else 
	if(point.y > -15 &&
	   point.y < -5)
	{//***** T *****
		point.x=(point.x+5)/10;
		if(point.x>=0 &&
		   point.x<=cx)
		{
			*pnLTRB=1;
			*pnOffset=point.x;
			return TRUE;
		}
	}else 
	if(point.x > cx*10+5 &&
	   point.x < cx*10+15)
	{//***** R *****
		point.y=(point.y+5)/10;
		if(point.y>=0 &&
		   point.y<=cy)
		{
			*pnLTRB=2;
			*pnOffset=point.y;
			return TRUE;
		}
	}else 
	if(point.y > cy*10+5 &&
	   point.y < cy*10+15)
	{//***** B *****
		point.x=(point.x+5)/10;
		if(point.x>=0 &&
		   point.x<=cx)
		{
			*pnLTRB=3;
			*pnOffset=point.x;
			return TRUE;
		}
	}
	return FALSE;
}




void CPartView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	SetFocus();
	if(!m_pPartInfo) return;

	CClientDC dc(this);
	PrepareDC(&dc);
	dc.DPtoLP(&point);
	
	int nLTRB,nOffset;

	if(IsOnPin(point,&nLTRB,&nOffset))
	{
		if(nLTRB  !=m_nSelectLTRB ||
		   nOffset!=m_nSelectOffset)
		{
			DrawCursor(&dc,FALSE);
			m_nSelectLTRB=nLTRB;
			m_nSelectOffset=nOffset;
			DrawCursor(&dc,TRUE);
			ScrollToPin(nLTRB,nOffset);
			PostSelChange();
		}
	}
	//CWnd::OnLButtonDown(nFlags, point);
}

void CPartView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	if(!m_pPartInfo) return;

	int nLTRB=m_nSelectLTRB;
	int nOffset=m_nSelectOffset;
	
	switch(nChar)
	{
	case VK_UP:
		if(m_nSelectLTRB==0 ||m_nSelectLTRB==2)
		{
			if(m_nSelectOffset<=0)
			{
				nLTRB=1;
				if(m_nSelectLTRB==0) nOffset=0;
				else nOffset=m_pPartInfo->m_size.cx;
			}else{
				nOffset=m_nSelectOffset-1;
			}
		}else if(m_nSelectLTRB==3) nLTRB=1;
		break;
	case VK_DOWN:
		if(m_nSelectLTRB==0 ||m_nSelectLTRB==2)
		{
			if(m_nSelectOffset>=m_pPartInfo->m_size.cy)
			{
				nLTRB=3;
				if(m_nSelectLTRB==0) nOffset=0;
				else nOffset=m_pPartInfo->m_size.cx;
			}else{
				nOffset=m_nSelectOffset+1;
			}
		}else if(m_nSelectLTRB==1) nLTRB=3;
		break;
	case VK_LEFT:
		if(m_nSelectLTRB==1 ||m_nSelectLTRB==3)
		{
			if(m_nSelectOffset<=0)
			{
				nLTRB=0;
				if(m_nSelectLTRB==1) nOffset=0;
				else nOffset=m_pPartInfo->m_size.cy;
			}else{
				nOffset=m_nSelectOffset-1;
			}
		}else if(m_nSelectLTRB==2) nLTRB=0;
		break;
	case VK_RIGHT:
		if(m_nSelectLTRB==1 ||m_nSelectLTRB==3)
		{
			if(m_nSelectOffset>=m_pPartInfo->m_size.cx)
			{
				nLTRB=2;
				if(m_nSelectLTRB==1) nOffset=0;
				else nOffset=m_pPartInfo->m_size.cy;
			}else{
				nOffset=m_nSelectOffset+1;
			}
		}else if(m_nSelectLTRB==0) nLTRB=2;
		break;
	}
	
	if(nLTRB  !=m_nSelectLTRB ||
	   nOffset!=m_nSelectOffset)
	{
		DrawCursor(NULL,FALSE);
		m_nSelectLTRB=nLTRB;
		m_nSelectOffset=nOffset;
		DrawCursor(NULL,TRUE);
		ScrollToPin(nLTRB,nOffset);
		PostSelChange();
	}			
}
